/*
        alph: Piper program implementing and analysing traditional and
        historic c(ai)phers designed to be used in conjuction with other
        programs.

        Copyright (C) 2004  Corcalciuc V. Horia

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public
        License as published by the Free Software Foundation; either
        version 2.1 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

*/

/* Errors */

#define KEYB	2		/* bad key. */
#define ENTO	3		/* entropy too short */
#define UNKN    1		/* unkown fault */

/* Decrypt-Encrypt */

typedef enum
{
  false = 0,
  true
} DoE;

DoE al_dec, al_enc;

/* Cyphers */

extern int caesar (char *org);	/* CAESAR */
extern int atbash (char *org);	/* ATBASH */
extern int rot13 (char *org);	/* ROT-13 */
extern int vigenere (char *org, char *key);	/* VIGENERE */
extern int vernam (char *org, char *afile);	/* VERNAM */
extern int playfair (char *org, char *key);	/* PLAYFAIR */
extern int bifidi (char *org, char *key); /* BIFIDI */
extern int enigma (char *org, char *rot, char *ref, char *ring);	/* ENIGMA */
