/*      
        alph: Piper program implementing and analysing traditional and
        historic c(ai)phers designed to be used in conjuction with other
        programs.

        Copyright (C) 2004  Corcalciuc V. Horia

        This library is free software; you can redistribute it and/or
        modify it under the terms of the GNU Lesser General Public
        License as published by the Free Software Foundation; either
        version 2.1 of the License, or (at your option) any later version.

        This library is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
        Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public
        License along with this library; if not, write to the Free Software
        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 US

*/

#include "alphCRYPT.h"

int
enigma (char *org, char *rot, char *ref, char *ring)
{

  char *dst;
  char p, over, tmp, last;
  int itra=0, ptr=0, curs=0, sem=0;
  char *lrot, *mrot, *rrot, rfl[13][2];  
  struct ring_set
    {
      int one;
      int two;
      int three;
    } *turn;

  char rotI[26] = 
    {
      'e', 'k', 'm', 'f', 'l', 
      'g', 'd', 'q', 'v', 'z', 
      'n', 't', 'o', 'w', 'y', 
      'h', 'x', 'u', 's', 'p', 
      'a', 'i', 'b', 'r', 'c', 
      'j'
     };

  char rotII[26] = 
    {  
      'a', 'j', 'd', 'k', 's',
      'i', 'r', 'u', 'x', 'b', 
      'l', 'h', 'w', 't', 'm', 
      'c', 'q', 'g', 'z', 'n', 
      'p', 'y', 'f', 'v', 'o', 
      'e'
    };

  char rotIII[26] = 
    {
      'b', 'd', 'f', 'h', 'j', 
      'l', 'c', 'p', 'r', 't', 
      'x', 'v', 'z', 'n', 'y', 
      'e', 'i', 'w', 'g', 'a', 
      'k', 'm', 'u', 's', 'q', 
      'o' 
    };
  
  char rotIV[26] =
    {
      'e', 's', 'o', 'v', 'p',   
      'z', 'j', 'a', 'y', 'q',   
      'u', 'i', 'r', 'h', 'x',   
      'l', 'n', 'f', 't', 'g',   
      'k', 'd', 'c', 'm', 'w',   
      'b'
    };

  char rotV[26] =
    {
      'v', 'z', 'b', 'r', 'g',   
      'i', 't', 'y', 'u', 'p', 
      's', 'd', 'n', 'h', 'l', 
      'x', 'a', 'w', 'm', 'j', 
      'q', 'o', 'f', 'e', 'c',
      'k'
    };

  char rotVI[26] =
    {
      'j', 'p', 'g', 'v', 'o', 
      'u', 'm', 'f', 'y', 'q',   
      'b', 'e', 'n', 'h', 'z',   
      'r', 'd', 'k', 'a', 's',   
      'x', 'l', 'i', 'c', 't',   
      'w'
    };

  char rotVII[26] =
    {
      'n', 'z', 'j', 'h', 'g',   
      'r', 'c', 'x', 'm', 'y',   
      's', 'w', 'b', 'o', 'u',   
      'f', 'a', 'i', 'v', 'l',   
      'p', 'e', 'k', 'q', 'd', 
      't'
    };

  char rotVIII[26] =
    {
      'f', 'k', 'q', 'h', 't',   
      'l', 'x', 'o', 'c', 'b',   
      'j', 's', 'p', 'd', 'z',   
      'r', 'a', 'm', 'e', 'w',   
      'n', 'i', 'u', 'y', 'g',   
      'v'
    };

  char rotb[26] =
    {
      'l', 'e', 'y', 'j', 'v',   
      'c', 'n', 'i', 'x', 'w',   
      'p', 'b', 'q', 'm', 'd',   
      'r', 't', 'a', 'k', 'z',   
      'g', 'f', 'u', 'h', 'o', 
      's'
    };

  char rotg[26] =
    {
      'f', 's', 'o', 'k', 'a',   
      'n', 'u', 'e', 'r', 'h',   
      'm', 'b', 't', 'i', 'y',   
      'c', 'w', 'l', 'q', 'p',   
      'z', 'x', 'v', 'g', 'j', 
      'd'
    };
  
  char refB[13][2] = 
    { 
      {'a','y'}, {'b','r'}, {'c','u'}, {'d','h'}, 
      {'e','q'}, {'f','s'}, {'g','l'}, {'i','p'}, 
      {'j','x'}, {'k','n'}, {'m','o'}, {'t','z'}, 
      {'v','w'}
	};
  char refC[13][2] = 
    { 
      {'a','f'}, {'b','v'}, {'c','p'}, {'d','j'},
      {'e','i'}, {'g','o'}, {'h','y'}, {'k','r'}, 
      {'l','z'}, {'m','x'}, {'n','w'}, {'t','q'}, 
      {'s','u'} 
    };
  char refBd[13][2] = 
    { 
      {'a','e'}, {'b','n'}, {'c','k'}, {'d','q'},
      {'f','u'}, {'g','y'}, {'h','w'}, {'i','j'},
      {'l','o'}, {'m','p'}, {'r','x'}, {'s','z'},
      {'t','v'}
    };
  char refCd[13][2] = 
    { 
      {'a','r'}, {'b','d'}, {'c','o'}, {'e','j'},
      {'f','n'}, {'g','t'}, {'h','k'}, {'i','v'},
      {'l','m'}, {'p','w'}, {'q','z'}, {'s','x'},
      {'u','y'}
    };


 for (itra=0; itra<3; itra++)
   if (rot[itra]=='1')
     {
       if (itra==0)
         lrot=rotI;
       if (itra==1)
         mrot=rotI;
       if (itra==2)
         rrot=rotI;
     }
   else if (rot[itra]=='2')
     {
       if (itra==0)
         lrot=rotII;
       if (itra==1)
         mrot=rotII;
       if (itra==2)
         rrot=rotII;
     }
   else if (rot[itra]=='3')
     {
       if (itra==0)
         lrot=rotIII;
       if (itra==1)
         mrot=rotIII;
       if (itra==2)
         rrot=rotIII;
     }
   else if (rot[itra]=='4')
     {
       if (itra==0)
         lrot=rotIV;
       if (itra==1)
         mrot=rotIV;
       if (itra==2)
         rrot=rotIV;
     }
   else if (rot[itra]=='5')
     {
       if (itra==0)
         lrot=rotV;
       if (itra==1)
         mrot=rotV;
       if (itra==2)
         rrot=rotV;
     }
   else if (rot[itra]=='6')
     {
       if (itra==0)
         lrot=rotVI;
       if (itra==1)
         mrot=rotVI;
       if (itra==2)
         rrot=rotVI;
     }
   else if (rot[itra]=='7')
     {
       if (itra==0)
         lrot=rotVII;
       if (itra==1)
         mrot=rotVII;
       if (itra==2)
         rrot=rotVII;
     }
   else if (rot[itra]=='8')
     {
       if (itra==0)
         lrot=rotVIII;
       if (itra==1)
         mrot=rotVIII;
       if (itra==2)
         rrot=rotVIII;
     }
   else if (rot[itra]=='b')
     {
       if (itra==0)
         lrot=rotb;
       if (itra==1)
         mrot=rotb;
       if (itra==2)
         rrot=rotb;
     }
   else if(rot[itra]=='g')
     {
       if (itra==0)
         lrot=rotg;
       if (itra==1)
         mrot=rotg;
       if (itra==2)
         rrot=rotg;
     }
 
 for (itra=0; itra<13; itra++)
   for (ptr=0; ptr<2; ptr++)
     switch (*ref)
       {
         case 'B':
           rfl[itra][ptr]=refB[itra][ptr];
           break;
         case 'C':
           rfl[itra][ptr]=refC[itra][ptr];
           break;
         case 'b':
           rfl[itra][ptr]=refBd[itra][ptr];
           break;
         case 'c':
           rfl[itra][ptr]=refCd[itra][ptr];
           break;
         default:
           return KEYB;
       }
 
 free(ref);

 turn=(struct ring *) calloc(1, sizeof(turn));
 while (curs++<3)
   if (ring[curs]>26 && ring[curs]<1)
     return KEYB;
   else if (curs==2)
     {
       turn->one=tolower(ring[2])-96;
       turn->two=tolower(ring[1])-96;
       turn->three=tolower(ring[0])-96;
     }
 
 for (ptr=turn->one-1; ptr>0; ptr--)
   {
     last=rrot[25];
     for (itra=1, over=rrot[itra-1]; itra<26; over=tmp, itra++) 
       {
         tmp=rrot[itra];
         rrot[itra]=over;
       }
     rrot[0]=last;
   }
 for (ptr=turn->two-1; ptr>0; ptr--)
   {
     last=rrot[25];
     for (itra=1, over=mrot[itra-1]; itra<26; over=tmp, itra++) 
       {
         tmp=mrot[itra];
         mrot[itra]=over;
       }
     mrot[0]=last;
   }
 for (ptr=turn->three-1; ptr>0; ptr--)
   {
     last=lrot[25];
     for (itra=1, over=lrot[itra-1]; itra<26; over=tmp, itra++) 
       {
         tmp=lrot[itra];
         lrot[itra]=over;
       }
     lrot[0]=last;
   }

 turn->one=0;
 turn->two=0;
 turn->three=0;
 
 dst=(char *) calloc(strlen(org), sizeof(char));
 for (curs=0, ptr=0, sem=0; curs<strlen(org)-1; curs++)
   {
     if (isupper(org[curs]))
       {
         org[curs]=tolower(org[curs]);
         sem++;
       }
     if (!isalpha(org[curs]))
       dst[curs]=org[curs];
     else
       {
      
         last=rrot[25];
         for (itra=1, over=rrot[itra-1]; itra<26; over=tmp, itra++) 
           {
             tmp=rrot[itra];
             rrot[itra]=over;
           }
          rrot[0]=last;
          turn->one++;

         if(turn->one==26)
           {
             turn->one=0;
             last=mrot[25];
             for (itra=1, over=mrot[itra-1]; itra<26; over=tmp, itra++)
               {
                 tmp=mrot[itra];
                 mrot[itra]=over;
               }
             mrot[0]=last;
             turn->two++;
           }
         if(turn->two==26)
           {
             turn->two=0;
             last=lrot[25];
             for (itra=1, over=lrot[itra-1]; itra<26; over=tmp, itra++)
               {
                 tmp=lrot[itra];
                 lrot[itra]=over;
               }
             lrot[0]=last;
             turn->three++;
           }

         p=org[curs];
         ptr=p-97;
         p=rrot[ptr];
         ptr=p-97;
         p=mrot[ptr];
         ptr=p-97;
         p=lrot[ptr];
      
         for (itra=0; itra<14; itra++)
           if (p==rfl[itra][0]) 
             {
               p=rfl[itra][1];
               break;
             }
            else if (p==rfl[itra][1])
             {
               p=rfl[itra][0];
               break;
             }
         for (itra=0; itra<26; itra++)
           if (p==lrot[itra])
             {
               ptr=itra;
               p=ptr+97;
               break;
             }
         for (itra=0; itra<26; itra++)
           if (p==mrot[itra])
             {
               ptr=itra;
               p=ptr+97;
               break;
             }
         for (itra=0; itra<26; itra++)
           if (p==rrot[itra])
             {
               ptr=itra;
               p=ptr+97;
               break;
             }
          dst[curs]=p;
       }
       if(sem)
         {
           dst[curs]=toupper(dst[curs]);
           sem--;
         }
   }
 
 strncpy(org, dst, strlen(dst));
 free(dst);
 return 0;

}

